/*  This file is part of the KDE libraries
    Copyright (C) 1998 Jrgen Hochwald (juergen.hochwald@privat.kkf.net

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this library; see the file COPYING.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.*/



#ifndef KSPLINEDLG_H
#define KSPLINEDLG_H
#include <stdio.h>
#include <qpushbt.h>
#include <qdialog.h>
#include <qlabel.h>
#include <krestrictedline.h>
#include <qchkbox.h>
#include "kspline.h"

/**
* Erweiterter Konfigurationsdialog fr KSplineEdit<br>
* Nur fr interne Verwendung
* @author Jrgen Hochwald
* @version 0.2 (5.7.1998)
*/
class KSplineDlg : public QDialog {
   Q_OBJECT
public:
   KSplineDlg(SplineCurve *Spl, QWidget* parent=0, const char* name=0);
   int setParams(void);
private:
   SplineCurve* Spline;
   KRestrictedLine* Y1Edit, *YnEdit;
   QCheckBox * NaturalCheck;
};

#endif
